git-am.shon commit Rename ".dotest/" to ".git/rebase" and ".dotest-merge" to "rebase-merge" (28ed6e7)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git-am [options] [<mbox>|<Maildir>...]
   9git-am [options] --resolved
  10git-am [options] --skip
  11--
  12d,dotest=       (removed -- do not use)
  13i,interactive   run interactively
  14b,binary        pass --allow-binary-replacement to git-apply
  153,3way          allow fall back on 3way merging if needed
  16s,signoff       add a Signed-off-by line to the commit message
  17u,utf8          recode into utf8 (default)
  18k,keep          pass -k flag to git-mailinfo
  19whitespace=     pass it through git-apply
  20C=              pass it through git-apply
  21p=              pass it through git-apply
  22resolvemsg=     override error message when patch failure occurs
  23r,resolved      to be used after a patch failure
  24skip            skip the current patch
  25rebasing        (internal use for git-rebase)"
  26
  27. git-sh-setup
  28prefix=$(git rev-parse --show-prefix)
  29set_reflog_action am
  30require_work_tree
  31cd_to_toplevel
  32
  33git var GIT_COMMITTER_IDENT >/dev/null ||
  34        die "You need to set your committer info first"
  35
  36stop_here () {
  37    echo "$1" >"$dotest/next"
  38    exit 1
  39}
  40
  41stop_here_user_resolve () {
  42    if [ -n "$resolvemsg" ]; then
  43            printf '%s\n' "$resolvemsg"
  44            stop_here $1
  45    fi
  46    cmdline=$(basename $0)
  47    if test '' != "$interactive"
  48    then
  49        cmdline="$cmdline -i"
  50    fi
  51    if test '' != "$threeway"
  52    then
  53        cmdline="$cmdline -3"
  54    fi
  55    echo "When you have resolved this problem run \"$cmdline --resolved\"."
  56    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
  57
  58    stop_here $1
  59}
  60
  61go_next () {
  62        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
  63                "$dotest/patch" "$dotest/info"
  64        echo "$next" >"$dotest/next"
  65        this=$next
  66}
  67
  68cannot_fallback () {
  69        echo "$1"
  70        echo "Cannot fall back to three-way merge."
  71        exit 1
  72}
  73
  74fall_back_3way () {
  75    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
  76
  77    rm -fr "$dotest"/patch-merge-*
  78    mkdir "$dotest/patch-merge-tmp-dir"
  79
  80    # First see if the patch records the index info that we can use.
  81    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
  82        "$dotest/patch" &&
  83    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  84    git write-tree >"$dotest/patch-merge-base+" ||
  85    cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
  86
  87    echo Using index info to reconstruct a base tree...
  88    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  89        git apply $binary --cached <"$dotest/patch"
  90    then
  91        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
  92        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
  93    else
  94        cannot_fallback "Did you hand edit your patch?
  95It does not apply to blobs recorded in its index."
  96    fi
  97
  98    test -f "$dotest/patch-merge-index" &&
  99    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 100    orig_tree=$(cat "$dotest/patch-merge-base") &&
 101    rm -fr "$dotest"/patch-merge-* || exit 1
 102
 103    echo Falling back to patching base and 3-way merge...
 104
 105    # This is not so wrong.  Depending on which base we picked,
 106    # orig_tree may be wildly different from ours, but his_tree
 107    # has the same set of wildly different changes in parts the
 108    # patch did not touch, so recursive ends up canceling them,
 109    # saying that we reverted all those changes.
 110
 111    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 112    export GITHEAD_$his_tree
 113    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 114            git rerere
 115            echo Failed to merge in the changes.
 116            exit 1
 117    }
 118    unset GITHEAD_$his_tree
 119}
 120
 121prec=4
 122dotest="$GIT_DIR/rebase"
 123sign= utf8=t keep= skip= interactive= resolved= binary= rebasing=
 124resolvemsg= resume=
 125git_apply_opt=
 126
 127while test $# != 0
 128do
 129        case "$1" in
 130        -i|--interactive)
 131                interactive=t ;;
 132        -b|--binary)
 133                binary=t ;;
 134        -3|--3way)
 135                threeway=t ;;
 136        -s|--signoff)
 137                sign=t ;;
 138        -u|--utf8)
 139                utf8=t ;; # this is now default
 140        --no-utf8)
 141                utf8= ;;
 142        -k|--keep)
 143                keep=t ;;
 144        -r|--resolved)
 145                resolved=t ;;
 146        --skip)
 147                skip=t ;;
 148        --rebasing)
 149                rebasing=t threeway=t keep=t binary=t ;;
 150        -d|--dotest)
 151                die "-d option is no longer supported.  Do not use."
 152                ;;
 153        --resolvemsg)
 154                shift; resolvemsg=$1 ;;
 155        --whitespace)
 156                git_apply_opt="$git_apply_opt $1=$2"; shift ;;
 157        -C|-p)
 158                git_apply_opt="$git_apply_opt $1$2"; shift ;;
 159        --)
 160                shift; break ;;
 161        *)
 162                usage ;;
 163        esac
 164        shift
 165done
 166
 167# If the dotest directory exists, but we have finished applying all the
 168# patches in them, clear it out.
 169if test -d "$dotest" &&
 170   last=$(cat "$dotest/last") &&
 171   next=$(cat "$dotest/next") &&
 172   test $# != 0 &&
 173   test "$next" -gt "$last"
 174then
 175   rm -fr "$dotest"
 176fi
 177
 178if test -d "$dotest"
 179then
 180        case "$#,$skip$resolved" in
 181        0,*t*)
 182                # Explicit resume command and we do not have file, so
 183                # we are happy.
 184                : ;;
 185        0,)
 186                # No file input but without resume parameters; catch
 187                # user error to feed us a patch from standard input
 188                # when there is already $dotest.  This is somewhat
 189                # unreliable -- stdin could be /dev/null for example
 190                # and the caller did not intend to feed us a patch but
 191                # wanted to continue unattended.
 192                tty -s
 193                ;;
 194        *)
 195                false
 196                ;;
 197        esac ||
 198        die "previous rebase directory $dotest still exists but mbox given."
 199        resume=yes
 200else
 201        # Make sure we are not given --skip nor --resolved
 202        test ",$skip,$resolved," = ,,, ||
 203                die "Resolve operation not in progress, we are not resuming."
 204
 205        # Start afresh.
 206        mkdir -p "$dotest" || exit
 207
 208        if test -n "$prefix" && test $# != 0
 209        then
 210                first=t
 211                for arg
 212                do
 213                        test -n "$first" && {
 214                                set x
 215                                first=
 216                        }
 217                        case "$arg" in
 218                        /*)
 219                                set "$@" "$arg" ;;
 220                        *)
 221                                set "$@" "$prefix$arg" ;;
 222                        esac
 223                done
 224                shift
 225        fi
 226        git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
 227                rm -fr "$dotest"
 228                exit 1
 229        }
 230
 231        # -b, -s, -u, -k and --whitespace flags are kept for the
 232        # resuming session after a patch failure.
 233        # -3 and -i can and must be given when resuming.
 234        echo "$binary" >"$dotest/binary"
 235        echo " $ws" >"$dotest/whitespace"
 236        echo "$sign" >"$dotest/sign"
 237        echo "$utf8" >"$dotest/utf8"
 238        echo "$keep" >"$dotest/keep"
 239        echo 1 >"$dotest/next"
 240        if test -n "$rebasing"
 241        then
 242                : >"$dotest/rebasing"
 243        else
 244                : >"$dotest/applying"
 245                git update-ref ORIG_HEAD HEAD
 246        fi
 247fi
 248
 249case "$resolved" in
 250'')
 251        files=$(git diff-index --cached --name-only HEAD --) || exit
 252        if [ "$files" ]; then
 253           echo "Dirty index: cannot apply patches (dirty: $files)" >&2
 254           exit 1
 255        fi
 256esac
 257
 258if test "$(cat "$dotest/binary")" = t
 259then
 260        binary=--allow-binary-replacement
 261fi
 262if test "$(cat "$dotest/utf8")" = t
 263then
 264        utf8=-u
 265else
 266        utf8=-n
 267fi
 268if test "$(cat "$dotest/keep")" = t
 269then
 270        keep=-k
 271fi
 272ws=`cat "$dotest/whitespace"`
 273if test "$(cat "$dotest/sign")" = t
 274then
 275        SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
 276                        s/>.*/>/
 277                        s/^/Signed-off-by: /'
 278                `
 279else
 280        SIGNOFF=
 281fi
 282
 283last=`cat "$dotest/last"`
 284this=`cat "$dotest/next"`
 285if test "$skip" = t
 286then
 287        git rerere clear
 288        this=`expr "$this" + 1`
 289        resume=
 290fi
 291
 292if test "$this" -gt "$last"
 293then
 294        echo Nothing to do.
 295        rm -fr "$dotest"
 296        exit
 297fi
 298
 299while test "$this" -le "$last"
 300do
 301        msgnum=`printf "%0${prec}d" $this`
 302        next=`expr "$this" + 1`
 303        test -f "$dotest/$msgnum" || {
 304                resume=
 305                go_next
 306                continue
 307        }
 308
 309        # If we are not resuming, parse and extract the patch information
 310        # into separate files:
 311        #  - info records the authorship and title
 312        #  - msg is the rest of commit log message
 313        #  - patch is the patch body.
 314        #
 315        # When we are resuming, these files are either already prepared
 316        # by the user, or the user can tell us to do so by --resolved flag.
 317        case "$resume" in
 318        '')
 319                git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
 320                        <"$dotest/$msgnum" >"$dotest/info" ||
 321                        stop_here $this
 322
 323                # skip pine's internal folder data
 324                grep '^Author: Mail System Internal Data$' \
 325                        <"$dotest"/info >/dev/null &&
 326                        go_next && continue
 327
 328                test -s "$dotest/patch" || {
 329                        echo "Patch is empty.  Was it split wrong?"
 330                        stop_here $this
 331                }
 332                if test -f "$dotest/rebasing" &&
 333                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 334                                -e q "$dotest/$msgnum") &&
 335                        test "$(git cat-file -t "$commit")" = commit
 336                then
 337                        git cat-file commit "$commit" |
 338                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 339                else
 340                        SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
 341                        case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
 342
 343                        (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
 344                                git stripspace > "$dotest/msg-clean"
 345                fi
 346                ;;
 347        esac
 348
 349        GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 350        GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 351        GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 352
 353        if test -z "$GIT_AUTHOR_EMAIL"
 354        then
 355                echo "Patch does not have a valid e-mail address."
 356                stop_here $this
 357        fi
 358
 359        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 360
 361        case "$resume" in
 362        '')
 363            if test '' != "$SIGNOFF"
 364            then
 365                LAST_SIGNED_OFF_BY=`
 366                    sed -ne '/^Signed-off-by: /p' \
 367                    "$dotest/msg-clean" |
 368                    sed -ne '$p'
 369                `
 370                ADD_SIGNOFF=`
 371                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 372                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 373                    echo "$SIGNOFF"
 374                }`
 375            else
 376                ADD_SIGNOFF=
 377            fi
 378            {
 379                if test -s "$dotest/msg-clean"
 380                then
 381                        cat "$dotest/msg-clean"
 382                fi
 383                if test '' != "$ADD_SIGNOFF"
 384                then
 385                        echo "$ADD_SIGNOFF"
 386                fi
 387            } >"$dotest/final-commit"
 388            ;;
 389        *)
 390                case "$resolved$interactive" in
 391                tt)
 392                        # This is used only for interactive view option.
 393                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 394                        ;;
 395                esac
 396        esac
 397
 398        resume=
 399        if test "$interactive" = t
 400        then
 401            test -t 0 ||
 402            die "cannot be interactive without stdin connected to a terminal."
 403            action=again
 404            while test "$action" = again
 405            do
 406                echo "Commit Body is:"
 407                echo "--------------------------"
 408                cat "$dotest/final-commit"
 409                echo "--------------------------"
 410                printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 411                read reply
 412                case "$reply" in
 413                [yY]*) action=yes ;;
 414                [aA]*) action=yes interactive= ;;
 415                [nN]*) action=skip ;;
 416                [eE]*) git_editor "$dotest/final-commit"
 417                       action=again ;;
 418                [vV]*) action=again
 419                       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
 420                *)     action=again ;;
 421                esac
 422            done
 423        else
 424            action=yes
 425        fi
 426        FIRSTLINE=$(sed 1q "$dotest/final-commit")
 427
 428        if test $action = skip
 429        then
 430                go_next
 431                continue
 432        fi
 433
 434        if test -x "$GIT_DIR"/hooks/applypatch-msg
 435        then
 436                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 437                stop_here $this
 438        fi
 439
 440        printf 'Applying %s\n' "$FIRSTLINE"
 441
 442        case "$resolved" in
 443        '')
 444                git apply $git_apply_opt $binary --index "$dotest/patch"
 445                apply_status=$?
 446                ;;
 447        t)
 448                # Resolved means the user did all the hard work, and
 449                # we do not have to do any patch application.  Just
 450                # trust what the user has in the index file and the
 451                # working tree.
 452                resolved=
 453                git diff-index --quiet --cached HEAD -- && {
 454                        echo "No changes - did you forget to use 'git add'?"
 455                        stop_here_user_resolve $this
 456                }
 457                unmerged=$(git ls-files -u)
 458                if test -n "$unmerged"
 459                then
 460                        echo "You still have unmerged paths in your index"
 461                        echo "did you forget to use 'git add'?"
 462                        stop_here_user_resolve $this
 463                fi
 464                apply_status=0
 465                git rerere
 466                ;;
 467        esac
 468
 469        if test $apply_status = 1 && test "$threeway" = t
 470        then
 471                if (fall_back_3way)
 472                then
 473                    # Applying the patch to an earlier tree and merging the
 474                    # result may have produced the same tree as ours.
 475                    git diff-index --quiet --cached HEAD -- && {
 476                        echo No changes -- Patch already applied.
 477                        go_next
 478                        continue
 479                    }
 480                    # clear apply_status -- we have successfully merged.
 481                    apply_status=0
 482                fi
 483        fi
 484        if test $apply_status != 0
 485        then
 486                echo Patch failed at $msgnum.
 487                stop_here_user_resolve $this
 488        fi
 489
 490        if test -x "$GIT_DIR"/hooks/pre-applypatch
 491        then
 492                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 493        fi
 494
 495        tree=$(git write-tree) &&
 496        parent=$(git rev-parse --verify HEAD) &&
 497        commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
 498        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 499        stop_here $this
 500
 501        if test -x "$GIT_DIR"/hooks/post-applypatch
 502        then
 503                "$GIT_DIR"/hooks/post-applypatch
 504        fi
 505
 506        go_next
 507done
 508
 509git gc --auto
 510
 511rm -fr "$dotest"